libstdc++: std::__cxx11::collate< _CharT > Class Template Reference

libstdc++

std::__cxx11::collate< _CharT > Class Template Reference

`#include <locale_classes.h>`

Inheritance diagram for std::__cxx11::collate< _CharT >:
[legend]

## Public Types
typedef _CharT | char_type
typedef basic_string< _CharT > | string_type

## Public Member Functions
| collate (__c_locale __cloc, size_t __refs=0)
| collate (size_t __refs=0)
int | _M_compare (const _CharT *, const _CharT *) const throw ()
size_t | _M_transform (_CharT *, const _CharT *, size_t) const throw ()
int | compare (const _CharT *__lo1, const _CharT *__hi1, const _CharT *__lo2, const _CharT *__hi2) const
long | hash (const _CharT *__lo, const _CharT *__hi) const
string_type | transform (const _CharT *__lo, const _CharT *__hi) const

## Static Public Attributes
static locale::id | id

## Protected Member Functions
virtual | ~collate ()
virtual int | do_compare (const _CharT *__lo1, const _CharT *__hi1, const _CharT *__lo2, const _CharT *__hi2) const
virtual long | do_hash (const _CharT *__lo, const _CharT *__hi) const
virtual string_type | do_transform (const _CharT *__lo, const _CharT *__hi) const

## Static Protected Member Functions
static __c_locale | _S_clone_c_locale (__c_locale &__cloc) throw ()
static void | _S_create_c_locale (__c_locale &__cloc, const char *__s, __c_locale __old=0)
static void | _S_destroy_c_locale (__c_locale &__cloc)
static __c_locale | _S_get_c_locale ()
static const char * | _S_get_c_name () throw ()
static __c_locale | _S_lc_ctype_c_locale (__c_locale __cloc, const char *__s)

## Protected Attributes
__c_locale | _M_c_locale_collate

## Detailed Description

template<typename _CharT>
class std::__cxx11::collate< _CharT >

Facet for localized string comparison.

This facet encapsulates the code to compare strings in a localized manner.

The collate template uses protected virtual functions to provide the actual results. The public accessors forward the call to the virtual functions. These virtual functions are hooks for developers to implement the behavior they require from the collate facet.

Definition at line 688 of file locale_classes.h.

## Member Typedef Documentation

## ◆ char_type

template<typename _CharT>

typedef _CharT std::__cxx11::collate< _CharT >::char_type

Public typedefs.

Definition at line 694 of file locale_classes.h.

## ◆ string_type

template<typename _CharT>

typedef basic_string<_CharT> std::__cxx11::collate< _CharT >::string_type

Public typedefs.

Definition at line 695 of file locale_classes.h.

## Constructor & Destructor Documentation

## ◆ collate() [1/2]

template<typename _CharT>

std::__cxx11::collate< _CharT >::collate | ( | size_t | __refs = 0 | ) |
| inlineexplicit

Constructor performs initialization.

This is the constructor provided by the standard.

Parameters

  __refs | Passed to the base facet class.

Definition at line 715 of file locale_classes.h.

References std::locale::facet::facet().

Referenced by do_compare(), do_hash(), and do_transform().

## ◆ collate() [2/2]

template<typename _CharT>

std::__cxx11::collate< _CharT >::collate | ( | __c_locale | __cloc,
|  | size_t | __refs = 0 )
| inlineexplicit

Internal constructor. Not for general use.

This is a constructor for use by the library itself to set up new locales.

Parameters

  __cloc | The C locale.
  __refs | Passed to the base facet class.

Definition at line 729 of file locale_classes.h.

References std::locale::facet::facet().

## ◆ ~collate()

template<typename _CharT>

virtual std::__cxx11::collate< _CharT >::~collate | ( |  | ) |
| inlineprotectedvirtual

Destructor.

Definition at line 792 of file locale_classes.h.

## Member Function Documentation

## ◆ _M_compare()

template<typename _CharT>

int std::collate< _CharT >::_M_compare | ( | const _CharT * | ,
|  | const _CharT * | ) const
throw | ( | ) |  |  |

Definition at line 238 of file locale_classes.tcc.

## ◆ _M_transform()

template<typename _CharT>

size_t std::collate< _CharT >::_M_transform | ( | _CharT * | ,
|  | const _CharT * | ,
|  | size_t | ) const
throw | ( | ) |  |  |

Definition at line 244 of file locale_classes.tcc.

## ◆ compare()

template<typename _CharT>

int std::__cxx11::collate< _CharT >::compare | ( | const _CharT * | __lo1,
|  | const _CharT * | __hi1,
|  | const _CharT * | __lo2,
|  | const _CharT * | __hi2 ) const
| inline

Compare two strings.

This function compares two strings and returns the result by calling collate::do_compare().

Parameters

  __lo1 | Start of string 1.
  __hi1 | End of string 1.
  __lo2 | Start of string 2.
  __hi2 | End of string 2.

Returns
  1 if string1 > string2, -1 if string1 < string2, else 0.

Definition at line 746 of file locale_classes.h.

References do_compare().

## ◆ do_compare()

template<typename _CharT>

int std::collate< _CharT >::do_compare | ( | const _CharT * | __lo1,
|  | const _CharT * | __hi1,
|  | const _CharT * | __lo2,
|  | const _CharT * | __hi2 ) const
| protectedvirtual

Compare two strings.

This function is a hook for derived classes to change the value returned.

See also
  compare().

Parameters

  __lo1 | Start of string 1.
  __hi1 | End of string 1.
  __lo2 | Start of string 2.
  __hi2 | End of string 2.

Returns
  1 if string1 > string2, -1 if string1 < string2, else 0.

Definition at line 249 of file locale_classes.tcc.

References collate(), std::basic_string< _CharT, _Traits, _Alloc >::c_str(), std::basic_string< _CharT, _Traits, _Alloc >::data(), and std::basic_string< _CharT, _Traits, _Alloc >::length().

Referenced by compare().

## ◆ do_hash()

template<typename _CharT>

long std::collate< _CharT >::do_hash | ( | const _CharT * | __lo,
|  | const _CharT * | __hi ) const
| protectedvirtual

Return hash of a string.

This function computes and returns a hash on the input string. This function is a hook for derived classes to change the value returned.

Parameters

  __lo | Start of string.
  __hi | End of string.

Returns
  Hash value.

Definition at line 377 of file locale_classes.tcc.

References collate().

Referenced by hash().

## ◆ do_transform()

template<typename _CharT>

collate< _CharT >::string_type std::collate< _CharT >::do_transform | ( | const _CharT * | __lo,
|  | const _CharT * | __hi ) const
| protectedvirtual

Transform string to comparable form.

This function is a hook for derived classes to change the value returned.

Parameters

  __lo | Start.
  __hi | End.

Returns
  transformed string.

Definition at line 288 of file locale_classes.tcc.

References collate(), std::basic_string< _CharT, _Traits, _Alloc >::append(), std::basic_string< _CharT, _Traits, _Alloc >::c_str(), std::basic_string< _CharT, _Traits, _Alloc >::clear(), std::basic_string< _CharT, _Traits, _Alloc >::data(), std::basic_string< _CharT, _Traits, _Alloc >::length(), and std::basic_string< _CharT, _Traits, _Alloc >::push_back().

Referenced by transform().

## ◆ hash()

template<typename _CharT>

long std::__cxx11::collate< _CharT >::hash | ( | const _CharT * | __lo,
|  | const _CharT * | __hi ) const
| inline

Return hash of a string.

This function computes and returns a hash on the input string. It does so by returning collate::do_hash().

Parameters

  __lo | Start of string.
  __hi | End of string.

Returns
  Hash value.

Definition at line 779 of file locale_classes.h.

References do_hash().

## ◆ transform()

template<typename _CharT>

string_type std::__cxx11::collate< _CharT >::transform | ( | const _CharT * | __lo,
|  | const _CharT * | __hi ) const
| inline

Transform string to comparable form.

This function is a wrapper for strxfrm functionality. It takes the input string and returns a modified string that can be directly compared to other transformed strings. In the C locale, this function just returns a copy of the input string. In some other locales, it may replace two chars with one, change a char for another, etc. It does so by returning collate::do_transform().

Parameters

  __lo | Start of string.
  __hi | End of string.

Returns
  Transformed string_type.

Definition at line 765 of file locale_classes.h.

References do_transform().

## Member Data Documentation

## ◆ _M_c_locale_collate

template<typename _CharT>

__c_locale std::__cxx11::collate< _CharT >::_M_c_locale_collate
| protected

Definition at line 701 of file locale_classes.h.

## ◆ id

template<typename _CharT>

locale::id std::__cxx11::collate< _CharT >::id
| static

Numpunct facet id.

Definition at line 705 of file locale_classes.h.

The documentation for this class was generated from the following files:

- locale_classes.h
- locale_classes.tcc